
#include <stdio.h>
#include <stdlib.h>
#include "mrid.h"

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	double	D,w,keV,sum,W=0.0;
	int	l,m,n;

	struct List {
		double		W;
		char		*str;
		struct List	*next;
	} *next=NULL,**ptr=(&next),*list;

	if (argc!=2) {
	    (void)fputs("usage : " RID "_dcc dcc.txt\n",stderr); exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) {
		(void)fputs("file not found.\n",stderr); exit(1);
	    }

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%lf",&D)!=1 || D<=0.0) {
	    (void)fputs("bad density.\n",stderr); exit(1);
	}
	while (fgets(str,LEN,file)!=NULL &&
	       sscanf(str,"%lf%n",&w,&l)==1 && w>=0.0) {
	    for (m=l; sscanf(str+l,"%*s%n",&n)==0; l+=n) ;

	    if (m==l) {
		(void)fputs("missing chemical formula.\n",stderr); exit(1);
	    }
	    if ((*ptr=list=(struct List *)malloc(sizeof(struct List)))==NULL ||
		(list->str=(char *)malloc((size_t)(n=l-m)+1))==NULL) {
		(void)fputs("memory allocation error.\n",stderr); exit(1);
	    }
	    list->str[n]='\0'; while (n>0) list->str[--n]=str[--l];

	    W+=(list->W=w); *(ptr=(&(list->next)))=NULL;
	}
	if (next==NULL) {
	    (void)fputs("missing chemical composition.\n",stderr); exit(1);
	}
	if (file!=stdin) (void)fclose(file);

	while (scanf("%lf",&keV)==1) {
	    sum=0.0;
	    for (list=next; list!=NULL; list=list->next) {
		for (l=0; sscanf(list->str+l,"%s%n",str,&n)==1; l+=n)
		    SetAtomicTable(str);

		sum+=(list->W*MRID(keV)); ResetAtomicTable();
	    }
	    (void)printf("%lf\t%le\n",keV,D*sum/W);
	}
	while ((list=next)!=NULL) {
	    free(list->str); next=list->next; free(list);
	}
	return 0;
}
